"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.checkClipboardTypes = checkClipboardTypes;
exports.isPastedFile = isPastedFile;
function checkClipboardTypes(type, item) {
  var isDOMStringList = function isDOMStringList(t) {
    return !t.indexOf && !!t.contains;
  };
  return isDOMStringList(type) ? type.contains(item) : type.indexOf(item) > -1;
}
function isPastedFile(rawEvent) {
  var clipboardData = rawEvent.clipboardData;
  if (!clipboardData) {
    return false;
  }
  return checkClipboardTypes(clipboardData.types, 'Files');
}