"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.textColorPalette = void 0;
var _adfSchema = require("@atlaskit/adf-schema");
var _common = require("./common");
var _getColorMessage = _interopRequireDefault(require("./getColorMessage"));
var _paletteMessages = _interopRequireDefault(require("./paletteMessages"));
var mapPaletteColor = function mapPaletteColor(label, color) {
  var key = label.toLowerCase().replace(' ', '-');
  var message = (0, _getColorMessage.default)(_paletteMessages.default, key);
  return {
    value: color,
    label: label,
    border: _common.DEFAULT_BORDER_COLOR,
    message: message
  };
};

// row 1
var textColorPalette = exports.textColorPalette = [];
_adfSchema.colorPalette.forEach(function (label, color) {
  textColorPalette.push(mapPaletteColor(label, color));
});