import { Transaction } from '@atlaskit/editor-prosemirror/state';
import type { Command } from '../types/command';
import type { EditorCommand } from '../types/editor-command';
/**
 * Convert a EditorCommand to a standard Prosemirror Command.
 * The preferred approach to dispatching a `EditorCommand` is via the
 * `core.actions.execute` on `pluginInjectionAPI`. In some cases
 * the type may require a Command until we refactor this out and this
 * function is suitable for those cases.
 *
 * @param command A plugin command (a function that modifies and returns a `Transaction`)
 * @returns Command
 */
export declare function editorCommandToPMCommand(command: EditorCommand | undefined): Command;
/**
 * PassiveTransaction is used only to indicate that
 * an `EditorCommand` should return `true` but should not dispatch.
 */
export declare class PassiveTransaction extends Transaction {
    constructor();
}
