/// <reference types="react" />
import { jsx } from '@emotion/react';
import type { WrappedComponentProps } from 'react-intl-next';
import type { FileIdentifier, MediaClient } from '@atlaskit/media-client';
import type { MediaInlineAttrs, MediaSSR } from './types';
export interface MediaInlineImageCardProps {
    identifier: FileIdentifier;
    mediaClient?: MediaClient;
    isSelected?: boolean;
    isLazy?: boolean;
    serializeDataAttrs?: boolean;
    border?: {
        borderSize?: number;
        borderColor?: string;
    };
    ssr?: MediaSSR;
    shouldOpenMediaViewer?: boolean;
}
export declare const MediaInlineImageCardInternal: ({ mediaClient, identifier, isSelected, intl, alt, isLazy, width, height, border, ssr, serializeDataAttrs, shouldOpenMediaViewer, }: MediaInlineImageCardProps & WrappedComponentProps & MediaInlineAttrs) => jsx.JSX.Element;
export declare const MediaInlineImageCard: React.ComponentType<React.PropsWithChildren<MediaInlineImageCardProps & MediaInlineAttrs>>;
