import type { Schema } from '@atlaskit/editor-prosemirror/model';
import { Slice } from '@atlaskit/editor-prosemirror/model';
/**
 * Lift content out of "open" top-level bodiedExtensions.
 * Will not work if bodiedExtensions are nested, or when bodiedExtensions are not in the top level
 */
export declare const transformSliceToRemoveOpenBodiedExtension: (slice: Slice, schema: Schema) => Slice;
/**
 * Lift content out of "open" top-level multiBodiedExtensions.
 * Will not work if multiBodiedExtensions are nested, or when multiBodiedExtensions are not in the top level, which should never happen
 */
export declare const transformSliceToRemoveOpenMultiBodiedExtension: (slice: Slice, schema: Schema) => Slice;
