import type { RichMediaLayout as MediaSingleLayout } from '@atlaskit/adf-schema';
import type { EditorState } from '@atlaskit/editor-prosemirror/state';
import type { EditorContainerWidth } from '../../types';
export declare const layoutSupportsWidth: (layout: MediaSingleLayout) => boolean;
export declare function calcPxFromColumns(columns: number, lineLength: number, gridSize: number): number;
export declare function calcColumnsFromPx(width: number, lineLength: number, gridSize: number): number;
export declare function calcPxFromPct(pct: number, lineLength: number): number;
export declare function calcPctFromPx(width: number, lineLength: number): number;
export declare const wrappedLayouts: MediaSingleLayout[];
export declare const calcPctWidth: (containerWidth: EditorContainerWidth, pctWidth?: number, origWidth?: number, origHeight?: number) => number | undefined;
export declare const calcMediaPxWidth: (opts: {
    origWidth: number;
    origHeight: number;
    state?: EditorState | undefined;
    containerWidth: EditorContainerWidth;
    layout?: MediaSingleLayout | undefined;
    pctWidth?: number | undefined;
    pos?: number | undefined;
    resizedPctWidth?: number | undefined;
    isFullWidthModeEnabled?: boolean | undefined;
}) => number;
export declare const snapToGrid: (gridWidth: number, width: number, height: number, lineLength: number, gridSize: number) => {
    height: number;
    width: number;
};
